1000 REM ============================================================
1010 REM                   SERIAL EPROM PROGRAMMER
1020 REM                        written in
1030 REM                MICROSOFT BASIC for the IBM PC
1040 REM =============================================================
1050 REM
1060 REM =============================================================
1070 REM INITIALIZATION ROUTINE
1080 REM =============================================================
1090 KEY OFF
1100 LINE25$="BAUD RATE=\   \  EPROM=\    \  BASE PAGE=\   \"
1110 BR$="0000":EP$=BR$:BP$=BR$
1120 DEFINT A-Z:ON ERROR GOTO 4600
1130 STROBE=255:DUMMY=255:PAGE=0:BYTE=0:DATUM=255
1140 K$="VPNEOWHDIBSL":FORMAT$="PAGE=\\   BYTE=\\   DATA=\\"
1150 MIMAGE=0:MCRADDR=&H3FC:DELAY=100
1160 REM =============================================================
1170 REM MAIN BODY OF PROGRAM - KEY BOARD SEQUENCE
1180 REM =============================================================
1190 GOSUB 2250
1200 PRINT"================== SERIAL EPROM PROGRAMMER ================="
1210 PRINT"                     BAUD RATE SELECTION"
1220 PRINT
1230 PRINT"The SERIAL PORT programmer can operate at several different baud"
1240 PRINT"rates. Select the baud rate for your system from the list below :"
1250 PRINT
1260 PRINT"   (1) 300 baud"
1270 PRINT"   (2) 600 baud"
1280 PRINT"   (3) 1200 baud"
1290 PRINT"   (4) 2400 baud"
1300 PRINT"   (5) 4800 baud"
1310 PRINT"   (6) 9600 baud"
1320 PRINT
1330 PRINT"Enter the number of your selection --> ";:BAUD$=INPUT$(1)
1340 PRINT BAUD$:BAUD=VAL(BAUD$):IF BAUD>0 AND BAUD<7 THEN 1360
1350 PRINT"<<<<< BAUD RATE SELECTION ERROR >>>>>": GOTO 1330
1360 BR$=STR$(300*2^(BAUD-1))
1370 GOSUB 2250
1380 PRINT"================== SERIAL EPROM PROGRAMMER ================="
1390 PRINT"                     EPROM TYPE SELECTION"
1400 PRINT
1410 PRINT"The SERIAL EPROM programmer has the ability to program several"
1420 PRINT"different EPROMS. Select the type of EPROM from the list below:"
1430 PRINT
1440 PRINT"   (1) 2716"
1450 PRINT"   (2) 2732/2732A"
1460 PRINT"   (3) 2764"
1470 PRINT"   (4) 27128"
1480 PRINT
1490 PRINT"Enter the number of your selection --> ";:ESIZE$=INPUT$(1)
1500 PRINT ESIZE$:ESIZE=VAL(ESIZE$):IF ESIZE>0 AND ESIZE<5 THEN 1520
1510 PRINT "<<<<< EPROM TYPE ERROR >>>>>":GOTO 1490
1520 DSIZE=1024*2^ESIZE:PAGES=DSIZE/256
1530 EP1$=STR$(16*2^(ESIZE-1))
1540 EP$="27"+RIGHT$(EP1$,LEN(EP1$)-1)
1550 DIM ARRAY(DSIZE)
1560 GOSUB 2250:GOSUB 4790:GOSUB 2250
1570 PRINT "================= SERIAL EPROM PROGRAMMER ================="
1580 PRINT "                     CONDITION OF EPROM"
1590 PRINT
1600 PRINT"If the EPROM you are programming is fully erased then select"
1610 PRINT"'EPROM ERASED' from the selection list below. This will save"
1620 PRINT"the time required to read the EPROM into memory. If the EPROM"
1630 PRINT"has been partially programmed then select'PARTIALLY PROGRAMMED'"
1640 PRINT"and the EPROM will be read into memory prior to programming."
1650 PRINT
1660 PRINT"  (1) EPROM ERASED"
1670 PRINT"  (2) EPROM PARTIALLY PROGRAMMED"
1680 PRINT
1690 PRINT"Enter the number of your selection --> ";:ERA$=INPUT$(1)
1700 PRINT ERA$:PRINT:ERA=VAL(ERA$):IF ERA=2 THEN 1740
1710 IF ERA<> 1 THEN PRINT"<<<<< SELECTION ERROR >>>>>":GOTO 1690
1720 PRINT"<<<<< INITALIZING MEMORY - PLEASE WAIT >>>>>"
1730 FOR I=0 TO DSIZE-1:ARRAY(I)=255:NEXT I
1740 ON BAUD GOTO 1750,1760,1770,1780,1790,1800
1750 OPEN "COM1:300,n,8,1,rs,cs,ds" AS #3:GOTO 1810
1760 OPEN "COM1:600,n,8,1,rs,cs,ds" AS #3:GOTO 1810
1770 OPEN "COM1:1200,n,8,1,rs,cs,ds" AS #3:GOTO 1810
1780 OPEN "COM1:2400,n,8,1,rs,cs,ds" AS #3:GOTO 1810
1790 OPEN "COM1:4800,n,8,1,rs,cs,ds" AS #3:GOTO 1810
1800 OPEN "COM1:9600,n,8,1,rs,cs,ds" AS #3
1810 GOSUB 2250
1820 PRINT "================= SERIAL EPROM PROGRAMMER ================="
1830 PRINT "                  BASE PAGE INITIALIZATION"
1840 PRINT
1850 PRINT"The SERIAL EPROM programmer is driven by a keystroke oriented"
1860 PRINT"program. The keys are defined in a HELP menu. This help menu."
1870 PRINT"can be displayed at any time by typing the letter (H) after"
1880 PRINT"the program has been initialized."
1890 PRINT:PRINT
1900 PRINT"To initialize the program you must enter the base page"
1910 PRINT"address of the EPROM. This address is generally a HEX value"
1920 PRINT"corresponding to the beginning page of an even 2k boundry."
1930 PRINT"For example 00,08,B0,B8,etc."
1940 PRINT
1950 GOSUB 3770:REM                           SET BASE ADDRESS
1960 IF HFLAG=1 THEN HFLAG=0:GOTO 1950
1970 IF ERA=1 THEN 2000
1980 PRINT"A MEMORY IMAGE OF YOUR EPROM IS BEING MADE"
1990 GOSUB 3890:REM                           MAKE MEMORY IMAGE
2000 GOSUB 2880:REM                           DISPLAY HELP MENU
2010 PRINT:PRINT
2020 PRINT"YOUR PRESENT LOCATION IS:"
2030 GOSUB 2320:REM                           READ & DISPLAY DATA
2040 PRINT"COMMAND -->";
2050 IKEY$=INPUT$(1)
2060 IF IKEY$>="a" AND IKEY$<="z" THEN IKEY$=CHR$(ASC(IKEY$) AND 95)
2070 K=INSTR(K$,IKEY$):IF K=0 THEN PRINT "WHAT ?";:GOTO 2050
2080 HFLAG=0
2090 ON K GOSUB 3430,2380,2440,2160,2500,2660,2880,3550,3760,3980,4240,4400
2100 REM         V    P    N    E    O    W    H    D    I    B    S    L
2110 IF HFLAG=1 THEN GOSUB 2880
2120 IF HFLAG=1 OR IKEY$="H" THEN 2010 ELSE 2030
2130 REM =============================================================
2140 REM BURN EPROM AND END OPTION
2150 REM =============================================================
2160 GOSUB 3980
2170 IF IKEY$<>"N" THEN RETURN
2180 CLOSE:END
2190 REM =============================================================
2200 REM MAIN BODY ENDS HERE - SUBROUTINE MODULES FOLLOW
2210 REM =============================================================
2220 REM =============================================================
2230 REM DISPLAY STATUS LINE
2240 REM =============================================================
2250 CLS:LOCATE 25,1:PRINT USING LINE25$;BR$,EP$,BP$;
2260 PRINT "  COMMANDS: ";K$
2270 LOCATE 3,1,1:RETURN
2280 REM =============================================================
2290 REM =============================================================
2300 REM  DISPLAY LOCATION AND DATA
2310 REM =============================================================
2320 RDATA=ARRAY(PAGE*256+BYTE) AND 255:REM     GET DATUM FROM ARRAY
2330 PRINT USING FORMAT$;HEX$(BIAS+PAGE),HEX$(BYTE),HEX$(RDATA)
2340 RETURN
2350 REM =============================================================
2360 REM DECREMENT ADDRESS
2370 REM =============================================================
2380 IF PAGE=0 AND BYTE=0 THEN RETURN ELSE BYTE=BYTE-1
2390 IF BYTE=-1 THEN PAGE=PAGE-1:BYTE=255
2400 RETURN
2410 REM =============================================================
2420 REM INCREMENT ADDRESS
2430 REM =============================================================
2440 IF PAGE=PAGES-1 AND BYTE=255 THEN RETURN ELSE BYTE=BYTE+1
2450 IF BYTE=256 THEN PAGE=PAGE+1:BYTE=0
2460 RETURN
2470 REM =============================================================
2480 REM OFFSET TO NEW STARTING ADDRESS
2490 REM =============================================================
2500 ADD$="":PRINT:PRINT"ENTER NEW LOCATION IN HEXADECIMAL (hhhh) --> ";
2510 L$=INPUT$(1):PRINT L$;
2520 IF L$>="a" AND L$<="z" THEN L$=CHR$(ASC(L$) AND 95)
2530 IF L$="H" THEN HFLAG=1:RETURN
2540 IF L$="Q" THEN PRINT:RETURN
2550 ADD$=ADD$+L$:IF LEN(ADD$)=4 THEN PRINT ELSE 2510
2560 PAGE$=LEFT$(ADD$,2):BYTE$=RIGHT$(ADD$,2)
2570 CON$=PAGE$:GOSUB 3110:IF SUM=-1 THEN 2500
2580 PAGE=SUM-BIAS
2590 IF PAGE>PAGES-1 OR PAGE<0 THEN PRINT"<<<<< OUT OF RANGE >>>>>":GOTO 2500
2600 CON$=BYTE$:GOSUB 3110:IF SUM=-1 THEN 2500
2610 BYTE=SUM
2620 RETURN
2630 REM =============================================================
2640 REM WRITE TO ARRAY - BYTE BY BYTE
2650 REM =============================================================
2660 XFLAG=0:DATUM$="":PRINT"<<< WRITE MODE >>>  ENTER DATA IN HEX (hh) --> ";
2670 D$=INPUT$(1):PRINT D$;
2680 IF D$>="a" AND D$<="z" THEN D$=CHR$(ASC(D$) AND 95)
2690 IF D$="H" THEN HFLAG=1:RETURN
2700 IF D$="Q" THEN PRINT:RETURN
2710 IF D$="X" THEN XFLAG=1:DATUM$="":GOTO 2670
2720 DATUM$=DATUM$+D$:IF LEN(DATUM$)<>2 THEN 2670
2730 PRINT:CON$=DATUM$:GOSUB 3110:DATUM=SUM
2740 IF SUM=-1 THEN 2660
2750 IF (ARRAY(PAGE*256+BYTE) AND 255)<>255 AND XFLAG=0 THEN 2830
2760 DATUM=DATUM OR 256:REM                TAG LOCATION AS WRITTEN TO
2770 ARRAY(PAGE*256+BYTE)=DATUM:REM        WRITE DATUM TO ARRAY
2780 GOSUB 2320:REM                        DISPLAY WRITE TO ARRAY
2790 IF BYTE=255 AND PAGE=PAGES-1 THEN RETURN
2800 GOSUB 2440:REM                        INCREMENT ADDRESS
2810 GOSUB 2320:REM                        DISPLAY NEXT LOCATION
2820 GOTO 2660
2830 PRINT:PRINT"<<<<<< ILLEGAL WRITE TO PREVIOUSLY PROGRAMMED LOCATION >>>>>>"
2840 RETURN
2850 REM =============================================================
2860 REM HELP ROUTINE
2870 REM =============================================================
2880 GOSUB 2250:REM                      CLEAR SCREEN
2890 PRINT"To initialize the program you should enter the beginning page"
2900 PRINT"address of the EPROM to be programmed. This value is used when"
2910 PRINT"printing to the screen and as a bias value in the write modes."
2920 PRINT"The following single letter commands are used to control the"
2930 PRINT"modes of the EPROM programmer:":PRINT
2940 PRINT"     (I) INITIALIZE BASE PAGE ADDRESS - base address is ";BIAS$;"00"
2950 PRINT"     (V) VERIFY ERASURE"
2960 PRINT"     (N) DISPLAY NEXT BYTE"
2970 PRINT"     (P) DISPLAY PREVIOUS BYTE"
2980 PRINT"     (O) OFFSET TO NEW PAGE & BYTE"
2990 PRINT"     (L) LOAD ARRAY FROM DISK"
3000 PRINT"     (S) SAVE ARRAY ON DISK"
3010 PRINT"     (W) ENTER BYTE WRITE MODE      (use Q or H to exit,X to edit)"
3020 PRINT"     (D) HEX DUMP TO SCREEN"
3030 PRINT"     (B) ENTER 'BURN EPROM' MODE"
3040 PRINT"     (H) ENTER HELP MODE            (from any input statement)"
3050 PRINT"     (E) EXIT PROGRAM"
3060 RETURN
3070 REM =============================================================
3080 REM ***** CONVERT HEX TO DECIMAL *****
3090 REM ENTER WITH HEX STRING IN CON$,EXIT WITH DECIMAL VALUE IN SUM
3100 REM =============================================================
3110 SUM=0
3120 FOR I=1 TO LEN(CON$)
3130   X=ASC(MID$(CON$,(LEN(CON$)+1-I),1))
3140   IF X<48 OR X>70 THEN SUM=-1:I=LEN(CON$):GOTO 3190
3150   IF X>57 AND X<65 THEN SUM=-1:I=LEN(CON$):GOTO 3190
3160   IF X<64 THEN X=X-48 ELSE X=X-55
3170   SUM=SUM+(X*16^(I-1))
3180   IF SUM>255 OR SUM<0 THEN SUM=-1
3190   IF SUM=-1 THEN PRINT"<<<<< INPUT ERROR >>>>>"
3200 NEXT I:RETURN
3210 REM =============================================================
3220 REM WRITE A BYTE
3230 REM =============================================================
3240 WPAGE=PAGE OR 128:REM               SET WRITE PAGE (W/R=1)
3250 PRINT #3,CHR$(WPAGE);:REM           SEND WRITE PAGE
3260 PRINT #3,CHR$(BYTE);:REM            SET WRITE BYTE
3270 PRINT #3,CHR$(DATUM);:REM           DATA TO WRITE
3280 PRINT #3,CHR$(STROBE);:REM          WRITE STROBE
3290 FOR DEL=1 TO DELAY:NEXT DEL:REM     WRITE DELAY
3300 RETURN
3310 REM =============================================================
3320 REM READ A BYTE
3330 REM =============================================================
3340 PRINT #3,CHR$(PAGE);:REM            SET READ PAGE (W/R=0)
3350 PRINT #3,CHR$(BYTE);:REM            SET READ BYTE
3360 PRINT #3,CHR$(DUMMY);:REM           DUMMY DATA SENT
3370 PRINT #3,CHR$(STROBE);:REM          READ STROBE
3380 RDATA=ASC(INPUT$(1,#3)):REM         INPUT DATA
3390 RETURN
3400 REM =============================================================
3410 REM VERIFY ERASURE
3420 REM =============================================================
3430 PRINT:PRINT"VERIFYING THAT EPROM IS ERASED":PRINT
3440 BYTE=0:PAGE=0
3450 FOR PAGE=0 TO PAGES-1:V$=" OK"
3460   FOR BYTE=0 TO 255
3470     IF (ARRAY(PAGE*256+BYTE) AND 255)=255 THEN 3490
3480     V$="<<<<<< NOT ERASED >>>>>>"
3490   NEXT BYTE:PRINT"PAGE";PAGE;V$
3500 NEXT PAGE
3510 BYTE=0:PAGE=0:RETURN
3520 REM =============================================================
3530 REM DUMP TO SCREEN
3540 REM =============================================================
3550 GOSUB 2250
3560 FOR LN=1 TO 16
3570   DPAGE$=RIGHT$("0"+HEX$(BIAS+PAGE),2)
3580   DBYTE$=RIGHT$("0"+HEX$(BYTE),2)
3590   PRINT USING"\\";DPAGE$;DBYTE$;": ";
3600   FOR D=1 TO 16
3610     DDATA$=RIGHT$("0"+HEX$((ARRAY(PAGE*256+BYTE) AND 255)),2)
3620     PRINT USING"\ \";DDATA$;
3630     IF PAGE=PAGES-1 AND BYTE=255 THEN D=16:LN=16
3640     GOSUB 2440:IF BYTE MOD 16=0 THEN PRINT:D=16
3650   NEXT D
3660 NEXT LN:PRINT:PRINT
3670 IF PAGE=PAGES-1 AND BYTE=255 THEN PRINT"<<<<<< END OF EPROM >>>>>":RETURN
3680 PRINT"ENTER (C) TO CONTINUE OR (Q) TO EXIT DUMP --> ";:IKEY$=INPUT$(1)
3690 IF IKEY$>="a" AND IKEY$<="z" THEN IKEY$=CHR$(ASC(IKEY$) AND 95)
3700 PRINT IKEY$:PRINT:IF IKEY$="C" THEN 3560
3710 IF IKEY$="H" THEN HFLAG=1:RETURN
3720 IF IKEY$="Q" THEN RETURN ELSE 3680
3730 REM =============================================================
3740 REM SET BIAS ADDRESS
3750 REM =============================================================
3760 GOSUB 2250
3770 BIAS$="":PRINT:PRINT"ENTER BASE PAGE ADDRESS IN HEXADECIMAL (hh) --> ";
3780 B$=INPUT$(1):PRINT B$;
3790 IF B$>="a" AND B$<="z" THEN B$=CHR$(ASC(B$) AND 95)
3800 IF B$="H" THEN HFLAG=1:RETURN
3810 IF B$="Q" THEN PRINT:RETURN
3820 BIAS$=BIAS$+B$:IF LEN(BIAS$)<>2 THEN 3780
3830 PRINT
3840 CON$=BIAS$:GOSUB 3110:BIAS=SUM:PRINT:PRINT:IF SUM=-1 THEN 3770
3850 PAGE=0:BYTE=0:BP$=BIAS$+"00":GOSUB 2250:RETURN
3860 REM =============================================================
3870 REM READ EPROM TO ARRAY
3880 REM =============================================================
3890 PAGE=0:BYTE=0:GOSUB 2250
3900 GOSUB 3340
3910 ARRAY(PAGE*256+BYTE)=RDATA:IF BYTE=0 THEN PRINT"READING PAGE";PAGE
3920 BYTE=BYTE+1:IF BYTE=256 THEN PAGE=PAGE+1:BYTE=0
3930 IF PAGE<=PAGES-1 THEN 3900
3940 PRINT:PAGE=0:BYTE=0:RETURN
3950 REM =============================================================
3960 REM WRITE ARRAY TO EPROM
3970 REM =============================================================
3980 GOSUB 2250
3990 PRINT"<<<<<< BURN ALL PROGRAMMED BYTES ?? >>>>>> "
4000 PRINT
4010 PRINT"TYPE  (Y) TO PROGRAM EPROM"
4020 PRINT"      (Q) TO RETURN TO PROGRAM"
4030 PRINT"      (H) TO DISPLAY HELP MENU"
4040 PRINT"      (N) TO RETURN TO PROGRAM FROM 'BURN' MODE"
4050 PRINT"          TO ABORT PROGRAM IN 'EXIT' MODE."
4060 PRINT:PRINT"ENTER SELECTION --> ";:IKEY$=INPUT$(1)
4070 PRINT IKEY$
4080 IF IKEY$>="a" AND IKEY$<="z" THEN IKEY$=CHR$(ASC(IKEY$) AND 95)
4090 IF IKEY$="N" THEN RETURN
4100 IF IKEY$="H" THEN HFLAG=1:RETURN
4110 IF IKEY$="Q" THEN PRINT:RETURN
4120 IF IKEY$<>"Y" THEN 3990
4130 FOR ADD=0 TO DSIZE
4140   DATUM=ARRAY(ADD):IF DATUM <256 THEN 4190
4150   DATUM=DATUM AND 255:BYTE=ADD MOD 256:PAGE=(ADD-BYTE)/256
4160   PRINT "BURNING ";:GOSUB 2320
4170   GOSUB 3240:GOSUB 3340
4180   IF RDATA<>DATUM THEN PRINT "<<<<<< DATA NOT VERIFIED >>>>>>"
4190 NEXT ADD
4200 PRINT:BYTE=0:PAGE=0:RETURN
4210 REM =============================================================
4220 REM SAVE ARRAY IN DISK FILE
4230 REM =============================================================
4240 GOSUB 2250:PRINT"THE DISK FILE CREATED HERE WILL CONTAIN ALL THE DATA"
4250 PRINT"PRESENTLY CONTAINED IN YOUR EPROM MEMORY IMAGE AND"
4260 PRINT"WILL BE ASSIGNED THE FILE EXTENTION 'PRM'."
4270 PRINT"THE FOLLOWING IS A LIST OF EXISTING DISK FILES WITH"
4280 PRINT"THE FILE EXTENTION '.PRM'.":PRINT:PRINT
4290 FILES "*.PRM":PRINT:PRINT
4300 INPUT"ENTER THE FILENAME OF YOUR NEW DISK FILE --> ",FILENAME$
4310 IF FILENAME$="H" OR FILENAME$="h" THEN HFLAG=1:RETURN
4320 IF FILENAME$="Q" OR FILENAME$="q" THEN RETURN
4330 OPEN "O",#1,FILENAME$+".PRM"
4340 FOR I=0 TO DSIZE-1:PRINT #1,(ARRAY(I) AND 255);
4350   IF I MOD 256=0 THEN PRINT "SAVING PAGE";I/256
4360 NEXT I:CLOSE #1:RETURN
4370 REM =============================================================
4380 REM LOAD ARRAY FORM DISK
4390 REM =============================================================
4400 GOSUB 2250:PRINT:PRINT"THE FOLLOWING IS A LIST OF FILENAMES WITH THE FILE"
4410 PRINT"EXTENTION '.PRM'":PRINT:PRINT
4420 FILES "*.PRM":PRINT:PRINT
4430 INPUT"ENTER A FILENAME FROM THE LIST ABOVE -->",FILENAME$
4440 IF FILENAME$="H" OR FILENAME$="h" THEN HFLAG=1:RETURN
4450 IF FILENAME$="Q" OR FILENAME$="q" THEN RETURN
4460 OPEN "I",#1,FILENAME$+".PRM"
4470 FOR I=0 TO DSIZE-1:INPUT #1,DATUM
4480   IF I MOD 256=0 THEN PRINT "LOADING PAGE";I/256
4490   IF DATUM=255 OR DATUM=(ARRAY(I) AND 255) THEN 4560
4500   IF ARRAY(I)<>255 THEN 4520
4510   ARRAY(I)=DATUM OR 256:GOTO 4560
4520   PRINT"<<<<<< ILLEGAL INPUT DATA FROM FILE >>>>>>"
4530   PRINT"<<<<<< ATTEMPT TO WRITE OVER PROGRAMMED LOCATION >>>>>>"
4540   PRINT"<<<<<< PROGRAM HAS BEEN ABORTED >>>>>>"
4550   CLOSE#1:END
4560 NEXT I:CLOSE #1:RETURN
4570 REM =============================================================
4580 REM DISK ERROR ROUTINE
4590 REM =============================================================
4600 IF ERR=53 AND ERL=4290 THEN PRINT"NO PRM FILES":RESUME 4300
4610 IF ERR=53 AND ERL=4420 THEN PRINT"NO PRM FILES":GOTO 4670
4620 IF ERR=53 AND ERL=4460 THEN PRINT"UNKNOWN FILE":GOTO 4670
4630 IF ERR=61 THEN PRINT "DISK FULL":GOTO 4670
4640 IF ERR=57 THEN PRINT"RESET EPROM PROGRAMMER":GOTO 4670
4650 IF ERR=67 THEN PRINT"UNKNOWN FILENAME, DON'T TYPE '.PRM'":GOTO 4670
4660 CLOSE#1:PRINT "UNKNOWN ERROR #";ERR;"IN LINE #";ERL
4670 PRINT"PRESS ANY KEY TO CONTINUE --> ";:IKEY$=INPUT$(1):PRINT
4680 IF ERR=57 THEN RESUME 0
4690 HFLAG=1
4700 RESUME 2110
4710 ON ERROR GOTO 0
4720 REM =============================================================
4730 REM CONFIGURATION ROUTINE
4740 REM =============================================================
4750 DATA 255,255,196,255,196,255,196,255,255,196,255,196
4760 DATA 026,196,255,255,255,196,255,196,196,255,255,196
4770 DATA 196,255,196,196,255,255,196,255,196,255,255,255
4780 DATA 196,255,196,196,255,255,196,255,196,255,196,255
4790 IF ESIZE=1 THEN RESTORE 4750
4800 IF ESIZE=2 THEN RESTORE 4760
4810 IF ESIZE=3 THEN RESTORE 4770
4820 IF ESIZE=4 THEN RESTORE 4780
4830 LOCATE 1,22:PRINT "JUMPER CONFIGURATION"
4840 LOCATE 3,30:PRINT CHR$(201);CHR$(205);CHR$(205);CHR$(187)
4850 FOR I=4 TO 15
4860   LOCATE I,30:PRINT CHR$(199);"  ";CHR$(182);"J";I-3
4870 NEXT I
4880 LOCATE 16,30:PRINT CHR$(200);CHR$(205);CHR$(205);CHR$(188)
4890 FOR I=4 TO 15
4900   READ JUMPER
4910   LOCATE I,31:PRINT CHR$(JUMPER);CHR$(JUMPER)
4920 NEXT I
4930 LOCATE 4,38
4940 IF ESIZE=2 THEN PRINT"NOTE: INSTALL J1 FOR 2732A EPROMS"
4950 LOCATE 18,20:PRINT "If jumpers are not properly configured"
4960 LOCATE 19,20:PRINT "shut off programmer and set jumpers,"
4970 LOCATE 20,20:PRINT "then turn programmer back on."
4980 LOCATE 22,20:PRINT "Press any key to continue --> ";
4990 A$=INPUT$(1):RETURN
